package dk.au.daimi.rabbithunt.model;

import dk.au.daimi.rabbithunt.model.world.Direction;
import dk.au.daimi.rabbithunt.model.world.World;

/**
 * 1000 - 1100 (har fet 1217) 
 * @author Nicki T. Hansen
 * @version februar 2007
 */
public class RabbitBrain extends Brain
{
	// instance variables
	private Direction currentDirection, directionToFox, directionToFox2;
	private boolean haveSeenFox, fleeTime = false;
	private int distanceToFox, count = 0, distanceToFox2 = 25;
	private boolean sawFoxLastTurn;
	private int distanceToFoxLastTurn;
	private Direction directionToFoxLastTurn;
	
	// Distance er sig selv med frem til, men ikke med, det frste objekt.
	// (aldrig 0)
	// Asynkron bevgelse - Rabbit ser og bevger sig, s fox1, s fox2.
	// Man KAN rykke op i fox og slippe vk, men det er ret mystisk hvorfor
	/**
	 * Decides on a direction in which to move.
	 * 
	 * @return the direction in which the rabbit wants to move
	 */
	public RabbitBrain()
	{
		currentDirection = Direction.NONE;
	}
	// Distance er sig selv med frem til, men ikke med, det frste objekt.
	// (aldrig 0)
	// Asynkron bevgelse - Rabbit ser og bevger sig, s fox1, s fox2.
	// Hvis man str direkte op ad en fox, kan man g ind i den uden at blive drbt.
	public Direction decideMove()
	{
		// Frst de ting der skal gres hver tur.
		count++;
		fleeTime = false;
		if (haveSeenFox)
		{
			haveSeenFox = false;
			sawFoxLastTurn = true;
			distanceToFoxLastTurn = distanceToFox;
			directionToFoxLastTurn = directionToFox;
		} else
		{
			sawFoxLastTurn = false;
			distanceToFoxLastTurn = 25;
			directionToFoxLastTurn = Direction.NONE;
		}
		/////////////////////////////////////
		//
		// Kigger efter fox
		for (Direction direction : Direction.DIRECTIONS)
		{
			if (world.look(direction) == World.FOX)
			{
				if (!haveSeenFox)
				{
					directionToFox2 = null;
					haveSeenFox = true;
					directionToFox = direction;
					distanceToFox = (world.distance(direction));
					fleeTime = true;
				} else
				{
					directionToFox2 = direction;
					distanceToFox2 = world.distance(directionToFox2);
					if (distanceToFox2 == distanceToFox
							|| distanceToFox2 == distanceToFox + 1
							|| distanceToFox2 == distanceToFox - 1
							|| distanceToFox2 == distanceToFox - 2
							|| distanceToFox2 == distanceToFox + 2)
					{
						// Beregn passende evade-vektorer
						currentDirection = turnAwayFromTwoFoxes(direction, directionToFox);
						return currentDirection;
					} else
					{
						if (distanceToFox > distanceToFox2)
						{
							// 
							directionToFox2 = directionToFox;
							directionToFox = direction;
							distanceToFox2 = distanceToFox;
							distanceToFox = world.distance(direction);
							fleeTime = true;
						} else
						{
							// directionToFox = directionToFox
							// osv.
						}
					}
				}
			}
		}
		//Fungerer ikke :-(
		/**if (haveSeenFox && sawFoxLastTurn)
		{
			if (distanceToFoxLastTurn < distanceToFox && distanceToFox > 3)
			{
				if (world.look(Direction.turn(currentDirection, 4)) == World.EDGE
						&& (world.look(Direction.turn(currentDirection, 2)) == World.EDGE || world
								.look(Direction.turn(currentDirection, -2)) == World.EDGE))
				{
					currentDirection = Direction.turn(currentDirection, 4);
					return currentDirection;
				}
			}
		}
		**/
		//heller ikke
		/**
		if (haveSeenFox && sawFoxLastTurn)
		{
			if (directionToFoxLastTurn.equals(directionToFox) && distanceToFoxLastTurn > distanceToFox)
			{
				currentDirection = Direction.turn(currentDirection, 4);
				return currentDirection;
			}
			
		}
		**/
		// 
		// Flygter fra en fox
		currentDirection = flee();
		return currentDirection;
	}
	/**
	 * 
	 * @param turn Drejning fra directionToFox. Gr ikke imod fox2. 
	 * @return
	 */
	public boolean turnFromFox(int turn)
	{
		if (world.canMove(Direction.turn(directionToFox, turn))
				&& !(Direction.turn(directionToFox, turn).equals(directionToFox2)))
		{
			currentDirection = Direction.turn(directionToFox, turn);
			return true;
		} else if (world.canMove(Direction.turn(directionToFox, -turn))
				&& !(Direction.turn(directionToFox, -turn).equals(directionToFox2)))
		{
			currentDirection = Direction.turn(directionToFox, -turn);
			return true;
		}
		return false;
	}
	/**
	 * arbejder med currentDirection og directionToFox
	 * @return Den retning man skal flygte.
	 */
	public Direction flee()
	{
		//	 
		// Flygter fra en fox
		if (fleeTime)
		{
			// Lber skv zig-zag
			// count % X, det optimale af X er ret svrt at finde.
			// men 3 virker som et fornuftigt nummer (4-7 er ogs brugbare)
			if (count % 3 == 0)
			{
				if (turnFromFox(3))
					return currentDirection;
			}
			if (count % 3 != 0)
			{
				if (turnFromFox(-3))
					return currentDirection;
			}
			//Exx|EEE
			//ERF|xRx osv.
			//Exx|xFx
			if (world.distance(Direction.turn(directionToFox, 4)) == 1
					&& world.look(Direction.turn(directionToFox, 4)) == World.EDGE
					&& world.distance(directionToFox) == 1
					&& (directionToFox.equals(Direction.N)
							|| directionToFox.equals(Direction.E)
							|| directionToFox.equals(Direction.S) || directionToFox
							.equals(Direction.W)))
			{
				if (turnFromFox(0))
					return currentDirection;
			}
			//EEE|BBB
			//ERx|BRx osv.
			//ExF|BxF
			if (world.distance(Direction.turn(directionToFox, 2)) == 1
					&& world.distance(Direction.turn(directionToFox, 3)) == 1
					&& world.distance(Direction.turn(directionToFox, 4)) == 1
					&& world.distance(Direction.turn(directionToFox, -3)) == 1
					&& world.distance(Direction.turn(directionToFox, -2)) == 1
					&& world.distance(directionToFox) == 1)
			{
				turnFromFox(0);
				return currentDirection;
			}
			//
			////
			if (distanceToFox2 < distanceToFox)
			{
				if (turnFromFox(2))
					return currentDirection;
			}
			if (turnFromFox(4))
				return currentDirection;
			if (turnFromFox(2))
				return currentDirection;
			//EEE
			//ERx
			//ExF
			if (world.distance(Direction.turn(directionToFox, 2)) == 1
					&& world.distance(Direction.turn(directionToFox, 3)) == 1
					&& world.distance(Direction.turn(directionToFox, 4)) == 1
					&& world.distance(Direction.turn(directionToFox, -3)) == 1
					&& world.distance(Direction.turn(directionToFox, -2)) == 1
					&& world.distance(directionToFox) == 1)
			{
				turnFromFox(0);
				return currentDirection;
			}
			//
			if (turnFromFox(1))
				return currentDirection;
			if (turnFromFox(0))
				return currentDirection;
		}
		return Direction.NONE;
	}
	public Direction turnAwayFromTwoFoxes(Direction fox1, Direction fox2)
	{
		if (world.distance(fox1) == 1 && world.distance(fox2) == 1)
		{
			if (fox1.equals(Direction.turn(fox2, 1))
					|| fox1.equals(Direction.turn(fox2, -1)))
			{
				if (fox1.equals(Direction.N) || fox1.equals(Direction.E)
						|| fox1.equals(Direction.S) || fox1.equals(Direction.W))
				{
					directionToFox = fox1;
					directionToFox2 = fox2;
				} else
				{
					directionToFox = fox2;
					directionToFox2 = fox1;
				}
			}
			if (fox1.equals(Direction.turn(fox2, 2))
					|| fox1.equals(Direction.turn(fox2, -2)))
			{
				///////////////////////////////////////////////////***
				// XFX|xxx|osv.
				// XRF|FRX| Behver ikke sprge om "lov" frst, da den dr hvis
				// xxx|XFX| den rykker noget andet end det ryk.
				if ((fox1.equals(Direction.N) || fox1.equals(Direction.E)
						|| fox1.equals(Direction.S) || fox1.equals(Direction.W))
						&& (fox2.equals(Direction.N) || fox2.equals(Direction.E)
								|| fox2.equals(Direction.S) || fox2.equals(Direction.W)))
				{
					if (fox1.equals(Direction.N) && fox2.equals(Direction.E))
					{
						if (world.canMove(Direction.SW))
							return Direction.SW;
						else if (world.canMove(Direction.N))
							return Direction.N;
						else if (world.canMove(Direction.E))
							return Direction.E;
					}
					if (fox1.equals(Direction.N) && fox2.equals(Direction.W))
					{
						if (world.canMove(Direction.SE))
							return Direction.SE;
						else if (world.canMove(Direction.N))
							return Direction.N;
						else if (world.canMove(Direction.W))
							return Direction.W;
					}
					if (fox1.equals(Direction.S) && fox2.equals(Direction.E))
					{
						if (world.canMove(Direction.NW))
							return Direction.NW;
						else if (world.canMove(Direction.S))
							return Direction.S;
						else if (world.canMove(Direction.E))
							return Direction.E;
					}
					if (fox1.equals(Direction.S) && fox2.equals(Direction.W))
					{
						if (world.canMove(Direction.NE))
							return Direction.NE;
						else if (world.canMove(Direction.S))
							return Direction.S;
						else if (world.canMove(Direction.W))
							return Direction.W;
					}
				}
				///////////////////////////////////////////////***
				//xFx
				//xRx
				//xFx
				else if (fox1.equals(Direction.turn(fox2, 4))
						&& world.distance(fox1) == 1 && world.distance(fox2) == 1)
				{
					// her skal overvejes edges etc.
					return fox2;
				}
				// Hvornr er den her? 
				else if (fox1.equals(Direction.N) || fox1.equals(Direction.E)
						|| fox1.equals(Direction.S) || fox1.equals(Direction.W))
				{
					directionToFox = fox1;
					directionToFox2 = fox2;
				} else if (fox2.equals(Direction.N) || fox2.equals(Direction.E)
						|| fox2.equals(Direction.S) || fox2.equals(Direction.W))
				{
					directionToFox = fox2;
					directionToFox2 = fox1;
				}
			}
		}
		///////////////////////////////////////**********************
		//hvis fox1 eller fox2 er 2 eller mere vk
		// XRX
		// FXX  --skal g efter F i denne linie
		// XXXF
		else if (fox1.equals(Direction.turn(fox2, 2))
				|| fox1.equals(Direction.turn(fox2, -2))
				&& (fox1.equals(Direction.NE) || fox1.equals(Direction.SE)
						|| fox1.equals(Direction.NW) || fox1.equals(Direction.SW)))
		{
			if (world.distance(fox1) < world.distance(fox2))
				directionToFox = fox1;
		}
		//xxxF
		//xxxx
		//xRxx
		//Fxxx
		//// SKAL LAVE ALLE EKSEMPLER HVOR f1 er 1 vk, og f2 er 2 vk.
		if (fox1.equals(Direction.turn(fox2, 4)))
		{
			if (fox1.equals(Direction.NE) || fox1.equals(Direction.SE)
					|| fox1.equals(Direction.NW) || fox1.equals(Direction.SW))
			{
				if (world.distance(fox1) < world.distance(fox2))
				{
					directionToFox = fox1;
				} else
					directionToFox = fox2;
			} else
			{ // hmm skal lige workes lidt
				if (world.distance(fox1) == 1)
				{
					return fox1;
				}
				if (world.distance(fox2) == 1)
					return fox2;
				else
				{
					return flee();
				}
			}
		}
		//xFxx|xFxx|xxFx|Fxxx
		//xxxx|xRxx|xxRx|xxxx
		//xRxx|xxxx|xxxx|xxRF osv.
		//Fxxx|xxxF|Fxxx|xxxx
		if (fox1.equals(Direction.turn(fox2, 3))
				|| fox1.equals(Direction.turn(fox2, -3)))
		{
			if (fox1.equals(Direction.N) || fox1.equals(Direction.E)
					|| fox1.equals(Direction.S) || fox1.equals(Direction.W))
			{
				if (fox2.equals(Direction.turn(fox1, 3)))
				{
					if (world.canMove(Direction.turn(fox2, 3)))
						return Direction.turn(fox2, 3);
					else
						return fox1;
				} else
				{
					if (world.canMove(Direction.turn(fox1, 3)))
						return Direction.turn(fox1, 3);
					else
						return fox1;
				}
			}
		}
		//xxxx|xxFx|xFxx
		//FRxx|FxRx|xxxx   Kan rykke til Ftt, 3, 4
		//xxxx|xxxx|FRxx       osv.
		//xFxx|xxxx|xxxx
		if (fox1.equals(Direction.turn(fox2, 2))
				|| fox1.equals(Direction.turn(fox2, -2)))
		{
			if (world.distance(fox1) == 1)
			{
				if (world.distance(fox2) == 2)
				{
					if (fox2.equals(Direction.turn(fox1, 2)))
					{
						if (world.canMove(Direction.turn(fox1, -3)))
							return Direction.turn(fox1, -3);
					}
					if (fox2.equals(Direction.turn(fox1, -2)))
					{
						if (world.canMove(Direction.turn(fox1, 3)))
							return Direction.turn(fox1, 3);
					}
					if (world.canMove(Direction.turn(fox1, 4)))
						return Direction.turn(fox1, 4);
					else
						return fox1;
				}
			} else
			{
				if (world.distance(fox1) == 2)
				{
					if (fox1.equals(Direction.turn(fox2, 2)))
					{
						if (world.canMove(Direction.turn(fox2, -3)))
							return Direction.turn(fox2, -3);
					}
					if (fox2.equals(Direction.turn(fox2, -2)))
					{
						if (world.canMove(Direction.turn(fox2, 3)))
							return Direction.turn(fox2, 3);
					}
					if (world.canMove(Direction.turn(fox2, 4)))
						return Direction.turn(fox2, 4);
					else
						return fox2;
				}
			}
		}
		///////////////////////////////////////
		return flee();
	}
	// Pointsystem ************************************************
	// Hvis FRF, ryk til st eller vest (oveni rven) , det samme ved nord/syd
	// ************************************************************
	/**
	 * Ideer:
	 * - hvis den ser en fox laangt vk, skal den bare blive stende, og lade den komme -- Nope, drlig ide.
	 * Huske fox en tur tilbage og rykke "vk", s den ikke gr i en flde.
	 * - Hvis den rykker vk fra et hjrne, og en fox rykker ortogonalt vk fra samme hjrne, 
	 * s g en tilbage i stedet for frem (+-1 i stedet for +-3) 
	 */
}